<?php

namespace Drupal\routee_waymore\Controller;

use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\JsonResponse;

//use Drupal\routee_waymore\Services\HelloGenerator;
//use Symfony\Component\DependencyInjection\ContainerInterface;
/**
 * Defines HelloController class.
 */
class RouteeController extends ControllerBase {

    /**
     * Display the markup.
     *
     * @return array
     *   Return markup array.
     */
    public function content() {
        $obj_cus = array();
        $obj_order = [];
        $obj_product = [];
        $obj_wishlist = [];
        $obj_client = [];
        $obj_subscriber = [];
        $back_status_order = 0;
        $back_status_product = 0;
        $back_status_customer = 0;
        $back_status_wishlist = 0;
        $back_status_client = 0;
        $back_status_subscriber = 0;
        $rng1 = 0;
        $pquantity = [];
        $rng2 = 0;
        $totalp = '';
        $rng3 = 0;
        $rng4 = 0;
        $rng5 = 0;
        $limit = 100;
        $rngcl2 = 0;
        $pid = [];
        $i = 0;
        $j = 0;

        $database23 = \Drupal::database();

        $result23 = $database23->select('routee_waymore', 'rw')
                ->fields('rw')
                ->condition('status', '1', "=")
                ->condition('status_back', '0', "=")
                ->execute()
                ->fetchAll();
        if (!empty($result23)) {
            foreach ($result23 as $all) {
                //mass data code
                //start order data
                $database2 = \Drupal::database();
                $ordertotal = $database2->select('commerce_order', 'co')
                        ->fields('co')
                        ->condition('store_id', $all->store_id, "=")
                        ->execute()
                        ->fetchAll();

                $resultrange = $database23->select('routee_range', 'rr')
                        ->fields('rr')
                        ->condition('type', '1', "=")
                        ->condition('uuid', $all->uuid, "=")
                        ->condition('store_id', $all->store_id, "=")
                        ->execute()
                        ->fetchAll();
                if (!empty($resultrange)) {
                    foreach ($resultrange as $resoder) {
                        $rng1 = $resoder->range;
                        if ($resoder->range != count($ordertotal) && $resoder->range < count($ordertotal)) {
                            $range_update_order = $database2->update('routee_range')
                                    ->fields([
                                        'range' => $resoder->range + $limit,
                                    ])
                                    ->condition('store_id', $all->store_id, '=')
                                    ->condition('uuid', $all->uuid, '=')
                                    ->condition('type', 1, '=')
                                    ->condition('id', $resoder->id, '=')
                                    ->execute();
                        } else {
                            $range_update_order = $database2->update('routee_range')
                                    ->fields([
                                        'status' => 1,
                                    ])
                                    ->condition('store_id', $all->store_id, '=')
                                    ->condition('uuid', $all->uuid, '=')
                                    ->condition('type', 1, '=')
                                    ->condition('id', $resoder->id, '=')
                                    ->execute();
                        }
                    }
                }


                $result2 = $database2->select('commerce_order', 'co')
                        ->fields('co')
                        ->condition('store_id', $all->store_id, "=")
                        ->range($rng1, $limit)
                        ->execute()
                        ->fetchAll();

                if (count($ordertotal) <= $limit) {
                    if (!empty($ordertotal)) {
                        foreach ($ordertotal as $res) {
                            $oid = $res->order_id;
                            $status = $res->state;
                            $paymethod = $res->payment_method;
                            $database3 = \Drupal::database();
                            $resultpay = $database3->select('commerce_payment_method', 'cpm')
                                    ->fields('cpm')
                                    ->condition('method_id', $paymethod, "=")
                                    ->execute()
                                    ->fetchAll();
                            if (!empty($resultpay[0]->type)) {
                                $paymethod_name1 = $resultpay[0]->type;
                            } else {
                                $paymethod_name1 = '';
                            }
                            $paygateway = $res->payment_gateway;

                            $result3 = $database3->select('commerce_order_item', 'coi')
                                    ->fields('coi')
                                    ->condition('order_id', $oid, "=")
                                    ->execute()
                                    ->fetchAll();

                            if (!empty($result3)) {
                                $pid = [];
                                $pquantity = [];
                                foreach ($result3 as $res3) {
                                    if (!empty($res3->quantity)) {
                                        $pquantity[] = $res3->quantity;
                                    } else {
                                        $pquantity = [];
                                    }
                                    $totalp = $res3->total_price__number;
                                    $result4 = $database3->select('commerce_product_field_data', 'cpf')
                                            ->fields('cpf')
                                            ->condition('title', $res3->title, "=")
                                            ->execute()
                                            ->fetchAll();

                                    foreach ($result4 as $res4) {
                                        if (!empty($res4->product_id)) {
                                            $pid[] = $res4->product_id;
                                        } else {
                                            $pid = [];
                                        }
                                    }
                                    if (empty($pid)) {
                                        $result45 = $database3->select('commerce_product_variation_field_data', 'cpvfd')
                                                ->fields('cpvfd')
                                                ->condition('variation_id', $res3->purchased_entity, "=")
                                                ->execute()
                                                ->fetchAll();
                                        foreach ($result45 as $res45) {
                                            $pid[] = $res45->product_id;
                                        }
                                    }
                                }
                            }
                            $k1 = [];
                            if (!empty($pid)) {
                                for ($kk = 0; $kk < count($pid); $kk++) {
                                    $k1[] = [
                                        'product_id' => $pid[$kk],
                                        'quantity' => $pquantity[$kk],
                                    ];
                                }
                            }
                            $result5 = $database3->select('users_field_data', 'uf')
                                    ->fields('uf')
                                    ->condition('mail', $res->mail, "=")
                                    ->execute()
                                    ->fetchAll();
                            foreach ($result5 as $res5) {
                                $customer = $res5->uid;
                            }

                            $resultcus = $database3->select('profile', 'pro')
                                    ->fields('pro')
                                    ->condition('uid', $res->uid, "=")
                                    ->execute()
                                    ->fetch();
                            $resultcus1 = $database3->select('profile_revision__address', 'pra')
                                    ->fields('pra')
                                    ->condition('revision_id', $resultcus->revision_id, "=")
                                    ->execute()
                                    ->fetchAll();

                            /* 
                            * This below added to check if we have data less then limit in this case execute those data only once
                            * Added by Kapil Hanswal 
                            */
                            $limitless_data4 = $database3->select('routee_limitless', 'rl')
                                    ->fields('rl')
                                    ->condition('type', '1', "=")
                                    ->condition('uuid', $all->uuid, "=")
                                    ->condition('store_id', $all->store_id, "=")
                                    ->execute()
                                    ->fetchAll();                            

                            if ((!empty($pid) || !empty($pquantity)) && empty($limitless_data4)) {
                                $obj_order[] = ["order_details" =>
                                    [
                                        "customer_id" => $customer,
                                        "order_id" => $oid,
                                        "order_status" => $status,
                                        'payment_gateway' => $paygateway,
                                        "payment_method" => $paymethod_name1,
                                        "total_price" => $totalp
                                    ],
                                    "order_products" =>
                                    $k1,
                                ];
                            }                            
                        }                        
                    }

                    $back_status_order = 1;
                } else if (count($ordertotal) > $limit) {
                    if (!empty($result2)) {

                        foreach ($result2 as $res) {
                            $oid = $res->order_id;
                            $status = $res->state;
                            $paymethod = $res->payment_method;
                            $database3 = \Drupal::database();
                            $resultpay = $database3->select('commerce_payment_method', 'cpm')
                                    ->fields('cpm')
                                    ->condition('method_id', $paymethod, "=")
                                    ->execute()
                                    ->fetchAll();
                            if (isset($resultpay[0]->type)) {
                                $paymethod_name = $resultpay[0]->type;
                            } else {
                                $paymethod_name = '';
                            }
                            $paygate = $res->payment_gateway;

                            $result3 = $database3->select('commerce_order_item', 'coi')
                                    ->fields('coi')
                                    ->condition('order_id', $oid, "=")
                                    ->execute()
                                    ->fetchAll();

                            if (!empty($result3)) {
                                $pid = [];
                                $pquantity = [];
                                foreach ($result3 as $res3) {
                                    if (!empty($res3->quantity)) {
                                        $pquantity[] = $res3->quantity;
                                    } else {
                                        $pquantity = [];
                                    }
                                    $totalp = $res3->total_price__number;
                                    $result4 = $database3->select('commerce_product_field_data', 'cpf')
                                            ->fields('cpf')
                                            ->condition('title', $res3->title, "=")
                                            ->execute()
                                            ->fetchAll();

                                    foreach ($result4 as $res4) {
                                        if (!empty($res4->product_id)) {
                                            $pid[] = $res4->product_id;
                                        } else {
                                            $pid = [];
                                        }
                                    }
                                    if (empty($pid)) {
                                        $result45 = $database3->select('commerce_product_variation_field_data', 'cpvfd')
                                                ->fields('cpvfd')
                                                ->condition('variation_id', $res3->purchased_entity, "=")
                                                ->execute()
                                                ->fetchAll();
                                        foreach ($result45 as $res45) {
                                            if (!empty($res45->product_id)) {
                                                $pid[] = $res45->product_id;
                                            }
                                        }
                                    }
                                }
                            }
                            $k1 = [];
                            if (!empty($pid)) {
                                for ($kk = 0; $kk < count($pid); $kk++) {
                                    $k1[] = [
                                        'product_id' => $pid[$kk],
                                        'quantity' => $pquantity[$kk],
                                    ];
                                }
                            }
                            $result5 = $database3->select('users_field_data', 'uf')
                                    ->fields('uf')
                                    ->condition('mail', $res->mail, "=")
                                    ->execute()
                                    ->fetchAll();
                            foreach ($result5 as $res5) {
                                $customer = $res5->uid;
                            }

                            $resultcus = $database3->select('profile', 'pro')
                                    ->fields('pro')
                                    ->condition('uid', $res->uid, "=")
                                    ->execute()
                                    ->fetch();
                            $resultcus1 = $database3->select('profile_revision__address', 'pra')
                                    ->fields('pra')
                                    ->condition('revision_id', $resultcus->revision_id, "=")
                                    ->execute()
                                    ->fetchAll();

                            if (!empty($pid) || !empty($pquantity)) {
                                $obj_order[] = ["order_details" =>
                                    [
                                        "customer_id" => $customer,
                                        "order_id" => $oid,
                                        "order_status" => $status,
                                        'payment_gateway' => $paygate,
                                        "payment_method" => $paymethod_name,
                                        "total_price" => $totalp
                                    ],
                                    "order_products" =>
                                    $k1,
                                ];
                            }
                        }                        
                    }
                    $resultrangecheck = $database23->select('routee_range', 'rr')
                            ->fields('rr')
                            ->condition('type', '1', "=")
                            ->condition('uuid', $all->uuid, "=")
                            ->condition('store_id', $all->store_id, "=")
                            ->execute()
                            ->fetchAll();
                    if (empty(count($resultrangecheck))) {
                        $range = count($result2);
                        $database = \Drupal::database();
                        $database->insert('routee_range')->fields(
                                array(
                                    'uuid' => $all->uuid,
                                    'type' => 1,
                                    'range' => $range,
                                    'store_id' => $all->store_id,
                                    'category' => 'order',
                                    'username' => $all->username,
                                    'data' => count($ordertotal),
                                )
                        )->execute();
                    }
                }
                 
                // start customer 

                $databasecl = \Drupal::database();
                $qr2cl = $databasecl->query("select * from users_field_data ");
                $clienttotal = $qr2cl->fetchAll();

                $clientrange = $databasecl->select('routee_range', 'rr')
                        ->fields('rr')
                        ->condition('type', '2', "=")
                        ->condition('uuid', $all->uuid, "=")
                        ->condition('store_id', $all->store_id, "=")
                        ->execute()
                        ->fetchAll();
                if (!empty($clientrange)) {
                    foreach ($clientrange as $resclient) {
                        $rngcl2 = $resclient->range;
                        if ($resclient->range != count($clienttotal) && $resclient->range < count($clienttotal)) {
                            $range_update_client = $database2->update('routee_range')
                                    ->fields([
                                        'range' => $resclient->range + $limit,
                                    ])
                                    ->condition('store_id', $all->store_id, '=')
                                    ->condition('uuid', $all->uuid, '=')
                                    ->condition('type', 2, '=')
                                    ->condition('id', $resclient->id, '=')
                                    ->execute();
                        } else {
                            $range_update_client = $database2->update('routee_range')
                                    ->fields([
                                        'status' => 1,
                                    ])
                                    ->condition('store_id', $all->store_id, '=')
                                    ->condition('uuid', $all->uuid, '=')
                                    ->condition('type', 2, '=')
                                    ->condition('id', $resclient->id, '=')
                                    ->execute();
                        }
                    }
                }

                $qrcl = $databasecl->query("select * from users_field_data  limit $rngcl2,$limit ");
                $result22cl = $qrcl->fetchAll();

                if (count($clienttotal) <= $limit) {
                    if (!empty($clienttotal)) {
                        foreach ($clienttotal as $res22cl) {
                            /* 
                            * This below added to fetch mobile/phone number of user while he registered from front end
                            * Added by Kapil Hanswal 
                            */
                            $resultMobField = $database2->select('user__field_mobile_phone', 'ufmp')
                                    ->fields('ufmp')
                                    ->condition('entity_id', $res22cl->uid, "=")
                                    ->execute()
                                    ->fetchAll();

                            $result223 = $database2->select('commerce_order', 'co1')
                                    ->fields('co1')
                                    ->condition('store_id', $all->store_id, "=")
                                    ->condition('uid', $res22cl->uid, "=")
                                    ->execute()
                                    ->fetchAll();
                            $crpid = [];
                            $crpq = [];
                            foreach ($result223 as $ress) {                            
                                $oid = $ress->order_id;
                                $status = $ress->state;
                                $paymethod = $ress->payment_method;
                                $database3 = \Drupal::database();
                                $result33 = $database3->select('commerce_order_item', 'coi')
                                        ->fields('coi')
                                        ->condition('order_id', $oid, "=")
                                        ->execute()
                                        ->fetchAll();


                                foreach ($result33 as $res33) {
                                    $result43 = $database3->select('commerce_product_field_data', 'cpf')
                                            ->fields('cpf')
                                            ->condition('title', $res33->title, "=")
                                            ->execute()
                                            ->fetchAll();

                                    if ($ress->cart == 1) {

                                        $crpq[] = $res33->quantity;
                                    }
                                    foreach ($result43 as $res43) {
                                        if ($ress->cart == 1) {

                                            $crpid[] = $res43->product_id;
                                        }
                                    }
                                    if ($ress->cart == 1 && empty($crpid)) {
                                        $result45 = $database3->select('commerce_product_variation_field_data', 'cpvfd')
                                                ->fields('cpvfd')
                                                ->condition('variation_id', $res33->purchased_entity, "=")
                                                ->execute()
                                                ->fetchAll();
                                        foreach ($result45 as $res45) {
                                            $crpid[] = $res45->product_id;
                                        }
                                    }
                                }
                            }
                            $k = array();
                            if (!empty($crpid)) {
                                for ($kk = 0; $kk < count($crpid); $kk++) {
                                    $k[] = array(
                                        'product_id' => $crpid[$kk],
                                        'quantity' => $crpq[$kk],
                                    );
                                }
                            }
                            $val = '_value';
                            $muladd1 = array();
                            $resultcus1 = [];

                            $resultcus = $database3->select('profile', 'pro')
                                    ->fields('pro')
                                    ->condition('uid', $res22cl->uid, "=")
                                    ->execute()
                                    ->fetchAll();
                            if (!empty($resultcus)) {
                                foreach ($resultcus as $add) {

                                    $resultcus1[] = $database3->select('profile_revision__address', 'pra')
                                            ->fields('pra')
                                            ->condition('revision_id', $add->revision_id, "=")
                                            ->execute()
                                            ->fetchAll();
                                }
                            }
                            if (!empty($resultcus1)) {
                                foreach ($resultcus1 as $muladd) {
                                    $muladd1[] = array(
                                        "country" => $muladd[0]->address_country_code,
                                        "city" => $muladd[0]->address_locality,
                                        "address1" => $muladd[0]->address_address_line1,
                                        "postcode" => $muladd[0]->address_postal_code,
                                        "company" => $muladd[0]->address_organization
                                    );
                                }
                                $fname = $muladd[0]->address_given_name;
                                $lname = $muladd[0]->address_family_name;
                            } else {
                                $fname = '';
                                $lname = '';
                            }
                            if (!empty($all->phone_field)) {
                                $phone_field = $all->phone_field;
                                if (db_table_exists("user__$phone_field") != '') {
                                    $qr3 = $database3->query("select * from user__$phone_field  where revision_id=" . $res22cl->uid);
                                    $cusphone = $qr3->fetchAll();

                                    $fil = "$phone_field$val";
                                    foreach ($cusphone as $cus) {
                                        $phon = $cus->$fil;
                                    }
                                } else {
                                    $phon = '';
                                }
                            } else {
                                $phon = '';
                            }
                            
                            /* 
                            * This below added to fetch mobile/phone number of user while he registered from front end
                            * Added by Kapil Hanswal 
                            */
                            if(!empty($resultMobField[0]) && $resultMobField[0]->field_mobile_phone_value!='')
                            {
                                $phon = $resultMobField[0]->field_mobile_phone_value;
                            }
                            
                            /* 
                            * This below added to check if we have data less then limit in this case execute those data only once
                            * Added by Kapil Hanswal 
                            */
                            $limitless_data1 = $database3->select('routee_limitless', 'rl')
                                ->fields('rl')
                                ->condition('type', '2', "=")
                                ->condition('uuid', $all->uuid, "=")
                                ->condition('store_id', $all->store_id, "=")
                                ->execute()
                                ->fetchAll();
                            
                            /* 
                            * Modified below array to the acceptable format suggested in routee documentation
                            * Added by Kapil Hanswal 
                            */
                            if (empty($limitless_data1)) {
                                $obj_cus[] =  ["customer" =>
                                    [
                                        "id" => $res22cl->uid,
                                        "firstname" => $fname,
                                        "lastname" => $lname,
                                        "email" => $res22cl->mail,
                                        "phone" => $phon
                                    ],
                                    "addresses" =>
                                    $muladd1,
                                    "cart" =>
                                    [
                                        "cart_products" =>
                                        $k,
                                    ]
                                ];                                
                            }                                                                           
                        }
                    }                    
                    $back_status_client = 1;
                } else if (count($clienttotal) > $limit) {
                    if (!empty($result22cl)) {
                        foreach ($result22cl as $res22cl) {
                            /* 
                            * This below added to fetch mobile/phone number of user while he registered from front end
                            * Added by Kapil Hanswal 
                            */
                            $resultMobField = $database2->select('user__field_mobile_phone', 'ufmp')
                                    ->fields('ufmp')
                                    ->condition('entity_id', $res22cl->uid, "=")
                                    ->execute()
                                    ->fetchAll();

                            $result223 = $database2->select('commerce_order', 'co1')
                                    ->fields('co1')
                                    ->condition('store_id', $all->store_id, "=")
                                    ->condition('uid', $res22cl->uid, "=")
                                    ->execute()
                                    ->fetchAll();
                            $crpid = [];
                            $crpq = [];
                            foreach ($result223 as $ress) {                           
                                $oid = $ress->order_id;
                                $status = $ress->state;
                                $paymethod = $ress->payment_method;
                                $database3 = \Drupal::database();
                                $result33 = $database3->select('commerce_order_item', 'coi')
                                        ->fields('coi')
                                        ->condition('order_id', $oid, "=")
                                        ->execute()
                                        ->fetchAll();


                                foreach ($result33 as $res33) {
                                    $result43 = $database3->select('commerce_product_field_data', 'cpf')
                                            ->fields('cpf')
                                            ->condition('title', $res33->title, "=")
                                            ->execute()
                                            ->fetchAll();

                                    if ($ress->cart == 1) {

                                        $crpq[] = $res33->quantity;
                                    }
                                    foreach ($result43 as $res43) {
                                        if ($ress->cart == 1) {

                                            $crpid[] = $res43->product_id;
                                        }
                                    }
                                    if ($ress->cart == 1 && empty($crpid)) {
                                        $result45 = $database3->select('commerce_product_variation_field_data', 'cpvfd')
                                                ->fields('cpvfd')
                                                ->condition('variation_id', $res33->purchased_entity, "=")
                                                ->execute()
                                                ->fetchAll();
                                        foreach ($result45 as $res45) {
                                            $crpid[] = $res45->product_id;
                                        }
                                    }
                                }
                            }
                            $k = [];
                            if (!empty($crpid)) {
                                for ($kk = 0; $kk < count($crpid); $kk++) {
                                    $k[] = [
                                        'product_id' => $crpid[$kk],
                                        'quantity' => $crpq[$kk],
                                    ];
                                }
                            }
                            $val = '_value';
                            $muladd1 = [];
                            $resultcus1 = [];

                            $resultcus = $database3->select('profile', 'pro')
                                    ->fields('pro')
                                    ->condition('uid', $res22cl->uid, "=")
                                    ->execute()
                                    ->fetchAll();
                            if (!empty($resultcus)) {
                                foreach ($resultcus as $add) {

                                    $resultcus1[] = $database3->select('profile_revision__address', 'pra')
                                            ->fields('pra')
                                            ->condition('revision_id', $add->revision_id, "=")
                                            ->execute()
                                            ->fetchAll();
                                }
                            }
                            if (!empty($resultcus1)) {
                                foreach ($resultcus1 as $muladd) {
                                    $muladd1[] = [
                                        "country" => $muladd[0]->address_country_code,
                                        "city" => $muladd[0]->address_locality,
                                        "address1" => $muladd[0]->address_address_line1,
                                        "postcode" => $muladd[0]->address_postal_code,
                                        "company" => $muladd[0]->address_organization,
                                    ];
                                }
                                $fname = $muladd[0]->address_given_name;
                                $lname = $muladd[0]->address_family_name;
                            } else {
                                $fname = '';
                                $lname = '';
                            }
                            if (!empty($all->phone_field)) {
                                $phone_field = $all->phone_field;
                                if (db_table_exists("user__$phone_field") != '') {
                                    $qr3 = $database3->query("select * from user__$phone_field  where revision_id=" . $res22cl->uid);
                                    $cusphone = $qr3->fetchAll();

                                    $fil = "$phone_field$val";
                                    foreach ($cusphone as $cus) {
                                        $phon = $cus->$fil;
                                    }
                                } else {
                                    $phon = '';
                                }
                            } else {
                                $phon = '';
                            }

                            /* 
                            * This below added to fetch mobile/phone number of user while he registered from front end
                            * Added by Kapil Hanswal 
                            */
                            if(!empty($resultMobField[0]) && $resultMobField[0]->field_mobile_phone_value!='')
                            {
                                $phon = $resultMobField[0]->field_mobile_phone_value;
                            }

                            $obj_cus[] =  ["customer" =>
                                    [
                                        "id" => $res22cl->uid,
                                        "firstname" => $fname,
                                        "lastname" => $lname,
                                        "email" => $res22cl->mail,
                                        "phone" => $phon
                                    ],
                                    "addresses" =>
                                    $muladd1,
                                    "cart" =>
                                    [
                                        "cart_products" =>
                                        $k,
                                    ]
                                ];
                        }
                    }


                    $clientrangecheck = $database23->select('routee_range', 'rr')
                            ->fields('rr')
                            ->condition('type', '2', "=")
                            ->condition('uuid', $all->uuid, "=")
                            ->condition('store_id', $all->store_id, "=")
                            ->execute()
                            ->fetchAll();
                    if (empty(count($clientrangecheck))) {
                        $range = count($result22cl);
                        $database = \Drupal::database();
                        $database->insert('routee_range')->fields(
                                array(
                                    'uuid' => $all->uuid,
                                    'type' => 2,
                                    'range' => $range,
                                    'store_id' => $all->store_id,
                                    'category' => 'customer',
                                    'username' => $all->username,
                                    'data' => count($clienttotal),
                                )
                        )->execute();
                    }
                }

                //end customer
                //product data
                $producttotal = $database2->select('commerce_product__stores', 'cps')
                        ->fields('cps')
                        ->condition('stores_target_id', $all->store_id, "=")
                        ->execute()
                        ->fetchAll();
                $productrange = $database23->select('routee_range', 'rr')
                        ->fields('rr')
                        ->condition('type', '3', "=")
                        ->condition('uuid', $all->uuid, "=")
                        ->condition('store_id', $all->store_id, "=")
                        ->execute()
                        ->fetchAll();
                if (!empty($productrange)) {
                    foreach ($productrange as $resproduct) {
                        $rng3 = $resproduct->range;
                        if ($resproduct->range != count($producttotal) && $resproduct->range < count($producttotal)) {
                            $range_update_product = $database2->update('routee_range')
                                    ->fields([
                                        'range' => $resproduct->range + $limit,
                                    ])
                                    ->condition('store_id', $all->store_id, '=')
                                    ->condition('uuid', $all->uuid, '=')
                                    ->condition('type', 3, '=')
                                    ->condition('id', $resproduct->id, '=')
                                    ->execute();
                        } else {
                            $range_update_product = $database2->update('routee_range')
                                    ->fields([
                                        'status' => 1,
                                    ])
                                    ->condition('store_id', $all->store_id, '=')
                                    ->condition('uuid', $all->uuid, '=')
                                    ->condition('type', 3, '=')
                                    ->condition('id', $resproduct->id, '=')
                                    ->execute();
                        }
                    }
                }

                $resultproduct = $database2->select('commerce_product__stores', 'cps')
                        ->fields('cps')
                        ->condition('stores_target_id', $all->store_id, "=")
                        ->range($rng3, $limit)
                        ->execute()
                        ->fetchAll();
                if (count($producttotal) <= $limit) {
                    if (!empty($producttotal)) {
                        foreach ($producttotal as $resp) {
                            $product_load = \Drupal\commerce_product\Entity\Product::load($resp->entity_id);
                            $store = $product_load->stores[0]->target_id;
                            if (!empty($product_load->variations[0]->target_id)) {
                                $database = \Drupal::database();
                                $result = $database->select('commerce_product_variation_field_data', 'variation')
                                        ->fields('variation')
                                        ->condition('variation_id', $product_load->variations[0]->target_id)
                                        ->execute()
                                        ->fetchAll();
                                $price = $result[0]->price__number;
                                $price_currency_code = $result[0]->price__currency_code;
                                $sku = $result[0]->sku;
                                $vid = $product_load->variations[0]->target_id;
                            } else {
                                $price = '';
                                $price_currency_code = '';
                                $sku = '';
                                $vid = '';
                            }

                            $id = $product_load->product_id->value;

                            /* 
                            * This below added to generate product link
                            * Added by Kapil Hanswal 
                            */
                            $dpath = \Drupal::urlGenerator()->generateFromRoute('<front>', [], ['absolute' => TRUE]);
                            $prolinkgen = '/product/'.$id;
                            $resultprolink = $database23->select('url_alias', 'ua')
                                ->fields('ua')
                                ->condition('source', $prolinkgen, "=")
                                ->execute()
                                ->fetchAll();
                            $productlink = $dpath.$resultprolink[0]->alias;
                            //ends here    

                            if (!empty($id)) {
                                $resultqty1 = $database23->select('commerce_product_variation_field_data', 'cfd')
                                        ->fields('cfd')
                                        ->condition('product_id', $id, "=")
                                        ->execute()
                                        ->fetchAll();
                            }
                            $quan33 = 0;
                            $quan12 = [];
                            $quan3 = 0;
                            $resprodoptarr = [];

                            /* 
                            * This below added to generate image link
                            * Added by Kapil Hanswal 
                            */
                            if (!empty($resultqty1)) {
                                $fieldimg = $database23->select('commerce_product_variation__field_images', 'cpvfi')
                                    ->fields('cpvfi')
                                    ->condition('entity_id', $resultqty1[0]->variation_id, "=")
                                    ->range(0, 1)
                                    ->execute()
                                    ->fetchAll(); 
                                $fid = $fieldimg[0]->field_images_target_id;

                                $file = \Drupal\file\Entity\File::load($fid);
                                if(!empty($file))
                                {
                                    $file_uri1 = $file->getFileUri();

                                    $file_uri = \Drupal::request()->getSchemeAndHttpHost().file_url_transform_relative(file_create_url($file_uri1));
                                }
                                else
                                    $file_uri = '';                                
                            }
                            //ends here

                            $title = $product_load->title->value;
                            $body = $product_load->body->value;
                            $type = $product_load->type->value;


                            foreach ($resultqty1 as $resprodopt) {
                                    $quanindivar = 0;

                                    /* 
                                    * This below added to fetch color for the product variation
                                    * Added by Kapil Hanswal 
                                    */
                                    $resultcolor = $database23->select('commerce_product_variation__attribute_color', 'cpvac')
                                        ->fields('cpvac')
                                        ->condition('entity_id', $resprodopt->variation_id, "=")
                                        ->execute()
                                        ->fetchAll();
                                    if(!empty($resultcolor[0]))
                                    {
                                        $resultcolorval = $database23->select('commerce_product_attribute_value_field_data', 'cpavfd')
                                            ->fields('cpavfd')
                                            ->condition('attribute_value_id', $resultcolor[0]->attribute_color_target_id, "=")
                                            ->execute()
                                            ->fetchAll();
                                        $color = $resultcolorval[0]->name;
                                    }
                                    else
                                    {
                                        $color = '';
                                    }

                                    /* 
                                    * This below added to fetch the size of product variation
                                    * Added by Kapil Hanswal 
                                    */
                                    $resultsize = $database23->select('commerce_product_variation__attribute_size', 'cpvas')
                                        ->fields('cpvas')
                                        ->condition('entity_id', $resprodopt->variation_id, "=")
                                        ->execute()
                                        ->fetchAll();
                                    if(!empty($resultsize[0]))
                                    {
                                        $resultsizeval = $database23->select('commerce_product_attribute_value_field_data', 'cpavfd')
                                            ->fields('cpavfd')
                                            ->condition('attribute_value_id', $resultsize[0]->attribute_size_target_id, "=")
                                            ->execute()
                                            ->fetchAll();
                                        $size = $resultsizeval[0]->name;
                                    }    
                                    else
                                    {
                                        $size = '';
                                    }

                                    /* 
                                    * This below added to fetch product categories
                                    * Added by Kapil Hanswal 
                                    */
                                    $resultcat = $database23->select('search_api_db_products', 'sadp')
                                        ->fields('sadp')
                                        ->condition('product_id', $resprodopt->product_id, "=")
                                        ->execute()
                                        ->fetchAll();
                                    if(!empty($resultcat[0]))
                                    {
                                        $cat = [];
                                        $item_id = $resultcat[0]->item_id;

                                        $resultcat1 = $database23->select('search_api_db_products_field_product_categories', 'sadpfpc')
                                            ->fields('sadpfpc')
                                            ->condition('item_id', $item_id, "=")
                                            ->execute()
                                            ->fetchAll();

                                        foreach ($resultcat1 as $catval) {
                                            $resultcat2 = $database23->select('taxonomy_term_field_data', 'ttfd')
                                                ->fields('ttfd')
                                                ->condition('tid', $catval->value, "=")
                                                ->execute()
                                                ->fetchAll();
                                            $cat[] = $resultcat2[0]->name;
                                        }                                                                                
                                    }
                                    else
                                    {
                                        $cat = [];
                                    }

                                    /* 
                                    * This below added to calculate the stock quantity total and individual for each product variation
                                    * Added by Kapil Hanswal 
                                    */
                                    $resultqtyvariation = $database23->select('commerce_stock_transaction', 'cst')
                                        ->fields('cst')
                                        ->condition('entity_id', $resprodopt->variation_id, "=")
                                        ->execute()
                                        ->fetchAll();
                                    foreach ($resultqtyvariation as $qtyvari) {
                                        $quanindivar +=$qtyvari->qty;
                                    }

                                    $resultqty22 = $database23->select('commerce_stock_transaction', 'cst1')
                                            ->fields('cst1')
                                            ->condition('entity_id', $resprodopt->variation_id, "=")
                                            ->execute()
                                            ->fetchAll();
                                    foreach ($resultqty22 as $r) {
                                        if (!empty($r->entity_id)) {
                                            $quan12[] = $r->qty;
                                        }
                                    }
                                    
                                    /* 
                                    * Building array for each product variantion that will be used to send over routee
                                    * Added by Kapil Hanswal 
                                    */
                                    $resprodoptarr[] = [
                                        "option_id" => $resprodopt->variation_id,
                                        "size" => $size,
                                        "stock_quantity" => $quanindivar,
                                        "price" => $resprodopt->price__number,
                                        "discount" => [],
                                        "color" => $color,
                                        "price_currency_code" => $resprodopt->price__currency_code,
                                        "sku" => $resprodopt->sku,
                                    ];
                                }

                                //calculating total quantity for the product by Kapil Hanswal
                                foreach ($quan12 as $q12) {
                                    $quan3 +=($q12);
                                }
                            /* 
                            * This below added to check if data count is less than limit, if yes then only send once and not consider next time
                            * Added by Kapil Hanswal 
                            */
                            $limitless_data3 = $database23->select('routee_limitless', 'rl')
                                    ->fields('rl')
                                    ->condition('type', '3', "=")
                                    ->condition('uuid', $all->uuid, "=")
                                    ->condition('store_id', $all->store_id, "=")
                                    ->execute()
                                    ->fetchAll();
                            /* 
                            * Modified original array to the below one and added all the missing information
                            * Added by Kapil Hanswal 
                            */        
                            if (empty($limitless_data3)) {
                                $obj_product[] = [
                                    "product_id" => $id,
                                    "name" => $title,
                                    "price" => $price,
                                    "description" => $body,
                                    "short_description" => '',
                                    "categories" => $cat,
                                    "stock_quantity" => $quan3,
                                    "image_link" => $file_uri,
                                    "product_link" => $productlink,
                                    "product_options" => $resprodoptarr,
                                ];
                            }                            
                        }
                    }

                    $back_status_product = 1;
                } else if (count($producttotal) > $limit) {
                    $vid = '';
                    if (!empty($resultproduct)) {
                        foreach ($resultproduct as $resp) {
                            $product_load = \Drupal\commerce_product\Entity\Product::load($resp->entity_id);
                            $store = $product_load->stores[0]->target_id;
                            if (!empty($product_load->variations[0]->target_id)) {
                                $database = \Drupal::database();
                                $result = $database->select('commerce_product_variation_field_data', 'variation')
                                        ->fields('variation')
                                        ->condition('variation_id', $product_load->variations[0]->target_id)
                                        ->execute()
                                        ->fetchAll();
                                $price = $result[0]->price__number;
                                $price_currency_code = $result[0]->price__currency_code;
                                $sku = $result[0]->sku;
                                $vid = $product_load->variations[0]->target_id;
                            } else {
                                $price = '';
                                $price_currency_code = '';
                                $sku = '';
                                $vid = '';
                            }
                            $id = $product_load->product_id->value;

                            /* 
                            * This below added to generate product link
                            * Added by Kapil Hanswal 
                            */
                            $dpath = \Drupal::urlGenerator()->generateFromRoute('<front>', [], ['absolute' => TRUE]);
                            $prolinkgen = '/product/'.$id;
                            $resultprolink = $database23->select('url_alias', 'ua')
                                ->fields('ua')
                                ->condition('source', $prolinkgen, "=")
                                ->execute()
                                ->fetchAll();
                            $productlink = $dpath.$resultprolink[0]->alias;
                            //ends here    

                            if (!empty($id)) {
                                $resultqty1 = $database23->select('commerce_product_variation_field_data', 'cfd')
                                        ->fields('cfd')
                                        ->condition('product_id', $id, "=")
                                        ->execute()
                                        ->fetchAll();
                            }
                            $quan33 = 0;
                            $quan12 = [];
                            $quan3 = 0;
                            $resprodoptarr = [];

                            /* 
                            * This below added to generate image link
                            * Added by Kapil Hanswal 
                            */
                            if (!empty($resultqty1)) {
                                $fieldimg = $database23->select('commerce_product_variation__field_images', 'cpvfi')
                                    ->fields('cpvfi')
                                    ->condition('entity_id', $resultqty1[0]->variation_id, "=")
                                    ->range(0, 1)
                                    ->execute()
                                    ->fetchAll(); 
                                $fid = $fieldimg[0]->field_images_target_id;

                                $file = \Drupal\file\Entity\File::load($fid);
                                if(!empty($file))
                                {
                                    $file_uri1 = $file->getFileUri();

                                    $file_uri = \Drupal::request()->getSchemeAndHttpHost().file_url_transform_relative(file_create_url($file_uri1));
                                }
                                else
                                    $file_uri = '';                                
                            }
                            
                            $title = $product_load->title->value;
                            $body = $product_load->body->value;
                            $type = $product_load->type->value;

                            foreach ($resultqty1 as $resprodopt) {
                                $quanindivar = 0;

                                /* 
                                * This below added to fetch color of each product variation
                                * Added by Kapil Hanswal 
                                */
                                $resultcolor = $database23->select('commerce_product_variation__attribute_color', 'cpvac')
                                    ->fields('cpvac')
                                    ->condition('entity_id', $resprodopt->variation_id, "=")
                                    ->execute()
                                    ->fetchAll();
                                if(!empty($resultcolor[0]))
                                {
                                    $resultcolorval = $database23->select('commerce_product_attribute_value_field_data', 'cpavfd')
                                        ->fields('cpavfd')
                                        ->condition('attribute_value_id', $resultcolor[0]->attribute_color_target_id, "=")
                                        ->execute()
                                        ->fetchAll();
                                    $color = $resultcolorval[0]->name;
                                }
                                else
                                {
                                    $color = '';
                                }
                                
                                /* 
                                * This below added to fetch size of each product variation
                                * Added by Kapil Hanswal 
                                */
                                $resultsize = $database23->select('commerce_product_variation__attribute_size', 'cpvas')
                                    ->fields('cpvas')
                                    ->condition('entity_id', $resprodopt->variation_id, "=")
                                    ->execute()
                                    ->fetchAll();
                                if(!empty($resultsize[0]))
                                {
                                    $resultsizeval = $database23->select('commerce_product_attribute_value_field_data', 'cpavfd')
                                        ->fields('cpavfd')
                                        ->condition('attribute_value_id', $resultsize[0]->attribute_size_target_id, "=")
                                        ->execute()
                                        ->fetchAll();
                                    $size = $resultsizeval[0]->name;
                                }    
                                else
                                {
                                    $size = '';
                                }

                                /* 
                                * This below added to fetch product categories
                                * Added by Kapil Hanswal 
                                */
                                $resultcat = $database23->select('search_api_db_products', 'sadp')
                                    ->fields('sadp')
                                    ->condition('product_id', $resprodopt->product_id, "=")
                                    ->execute()
                                    ->fetchAll();
                                if(!empty($resultcat[0]))
                                {
                                    $cat = [];
                                    $item_id = $resultcat[0]->item_id;

                                    $resultcat1 = $database23->select('search_api_db_products_field_product_categories', 'sadpfpc')
                                        ->fields('sadpfpc')
                                        ->condition('item_id', $item_id, "=")
                                        ->execute()
                                        ->fetchAll();

                                    foreach ($resultcat1 as $catval) {
                                        $resultcat2 = $database23->select('taxonomy_term_field_data', 'ttfd')
                                            ->fields('ttfd')
                                            ->condition('tid', $catval->value, "=")
                                            ->execute()
                                            ->fetchAll();
                                        $cat[] = $resultcat2[0]->name;
                                    }                                                                                
                                }
                                else
                                {
                                    $cat = [];
                                }

                                /* 
                                * This below added to calculate total and individual product variation quantity
                                * Added by Kapil Hanswal 
                                */
                                $resultqtyvariation = $database23->select('commerce_stock_transaction', 'cst')
                                    ->fields('cst')
                                    ->condition('entity_id', $resprodopt->variation_id, "=")
                                    ->execute()
                                    ->fetchAll();
                                foreach ($resultqtyvariation as $qtyvari) {
                                    $quanindivar +=$qtyvari->qty;
                                }

                                $resultqty22 = $database23->select('commerce_stock_transaction', 'cst1')
                                        ->fields('cst1')
                                        ->condition('entity_id', $resprodopt->variation_id, "=")
                                        ->execute()
                                        ->fetchAll();
                                foreach ($resultqty22 as $r) {
                                    if (!empty($r->entity_id)) {
                                        $quan12[] = $r->qty;
                                    }
                                }

                                /* 
                                * Array for each product variation that will be used to send over routee
                                * Added by Kapil Hanswal 
                                */        
                                $resprodoptarr[] = [
                                    "option_id" => $resprodopt->variation_id,
                                    "size" => $size,
                                    "stock_quantity" => $quanindivar,
                                    "price" => $resprodopt->price__number,
                                    "discount" => [],
                                    "color" => $color,
                                    "price_currency_code" => $resprodopt->price__currency_code,
                                    "sku" => $resprodopt->sku,
                                ];
                            }
                            /* 
                            * This below added to calculate total quantity of product
                            * Added by Kapil Hanswal 
                            */
                            foreach ($quan12 as $q12) {
                                $quan3 +=($q12);
                            }
                            /* 
                            * Modified original array and added all the missing information.
                            * Added by Kapil Hanswal 
                            */
                            $obj_product[] = [
                                "product_id" => $id,
                                "name" => $title,
                                "price" => $price,
                                "description" => $body,
                                "short_description" => '',
                                "categories" => $cat,
                                "stock_quantity" => $quan3,
                                "image_link" => $file_uri,
                                "product_link" => $productlink,
                                "product_options" => $resprodoptarr,
                            ];
                        }
                    }
                    $productrangecheck = $database23->select('routee_range', 'rr')
                            ->fields('rr')
                            ->condition('type', '3', "=")
                            ->condition('uuid', $all->uuid, "=")
                            ->condition('store_id', $all->store_id, "=")
                            ->execute()
                            ->fetchAll();
                    if (empty(count($productrangecheck))) {
                        $range = count($resultproduct);
                        $database = \Drupal::database();
                        $database->insert('routee_range')->fields(
                                array(
                                    'uuid' => $all->uuid,
                                    'type' => 3,
                                    'range' => $range,
                                    'store_id' => $all->store_id,
                                    'category' => 'product',
                                    'username' => $all->username,
                                    'data' => count($producttotal),
                                )
                        )->execute();
                    }
                }
                //end product data
                //start wishlist data
                $wishtotal = [];

                $wishtotal1 = $database2->select('commerce_product__stores', 'cps')
                        ->fields('cps')
                        ->condition('stores_target_id', $all->store_id)
                        ->execute()
                        ->fetchAll();
                if (!empty($wishtotal1)) {
                    foreach ($wishtotal1 as $resw1) {
                        $resultwishid2 = $database2->select('commerce_product_variation_field_data', 'pro')
                                ->fields('pro')
                                ->condition('product_id', $resw1->entity_id)
                                ->execute()
                                ->fetchAll();

                        foreach ($resultwishid2 as $proid) {
                            $resultwish = $database2->select('commerce_wishlist_item', 'cwi')
                                    ->fields('cwi')
                                    ->condition('purchasable_entity', $proid->variation_id)
                                    ->execute()
                                    ->fetchAll();
                            if (!empty($resultwish)) {
                                $wishtotal[] = count($resultwish);
                            }
                        }
                    }
                }
                $wishrange = $database23->select('routee_range', 'rr')
                        ->fields('rr')
                        ->condition('type', '4', "=")
                        ->condition('uuid', $all->uuid, "=")
                        ->condition('store_id', $all->store_id, "=")
                        ->execute()
                        ->fetchAll();
                if (!empty($wishrange)) {
                    foreach ($wishrange as $reswish) {
                        $rng4 = $reswish->range;
                        if ($reswish->range != count($wishtotal1) && $reswish->range < count($wishtotal1)) {
                            $range_update_wish = $database2->update('routee_range')
                                    ->fields([
                                        'range' => $reswish->range + $limit,
                                    ])
                                    ->condition('store_id', $all->store_id, '=')
                                    ->condition('uuid', $all->uuid, '=')
                                    ->condition('type', 4, '=')
                                    ->condition('id', $reswish->id, '=')
                                    ->execute();
                        } else {
                            $range_update_wish = $database2->update('routee_range')
                                    ->fields([
                                        'status' => 1,
                                    ])
                                    ->condition('store_id', $all->store_id, '=')
                                    ->condition('uuid', $all->uuid, '=')
                                    ->condition('type', 4, '=')
                                    ->condition('id', $reswish->id, '=')
                                    ->execute();
                        }
                    }
                }

                $resultwish1 = $database2->select('commerce_product__stores', 'cps')
                        ->fields('cps')
                        ->condition('stores_target_id', $all->store_id)
                        ->range($rng4, $limit)
                        ->execute()
                        ->fetchAll();
                if (count($wishtotal1) <= $limit) {
                    if (!empty($wishtotal1)) {
                        foreach ($wishtotal1 as $resw1) {
                            $resultwishid2 = $database2->select('commerce_product_variation_field_data', 'pro')
                                    ->fields('pro')
                                    ->condition('product_id', $resw1->entity_id)
                                    ->execute()
                                    ->fetchAll();
                             if (!empty($resultwishid2)) {
                            foreach ($resultwishid2 as $proid) {
                                $resultwish = $database2->select('commerce_wishlist_item', 'cwi')
                                        ->fields('cwi')
                                        ->condition('purchasable_entity', $proid->variation_id)
                                        ->execute()
                                        ->fetchAll();

                                $limitless_data5 = $database2->select('routee_limitless', 'rl')
                                        ->fields('rl')
                                        ->condition('type', '4', "=")
                                        ->condition('uuid', $all->uuid, "=")
                                        ->condition('store_id', $all->store_id, "=")
                                        ->execute()
                                        ->fetchAll();
                                
                                if (!empty($resultwish) && empty($limitless_data5)) {

                                    foreach ($resultwish as $resw2) {
                                        $resultwishid = $database2->select('commerce_wishlist', 'cww')
                                                ->fields('cww')
                                                ->condition('wishlist_id', $resw2->wishlist_id)
                                                ->execute()
                                                ->fetchAll();
                                        $obj_wishlist[] = [
                                            'customer_id' => $resultwishid[0]->uid,
                                            'product_id' => $resw1->entity_id,
                                        ];
                                    }
                                }
                            }
                        }
                    }
                    }
                    $back_status_wishlist = 1;
                } else if (count($wishtotal1) > $limit) {
                    if (!empty($resultwish1)) {
                        foreach ($resultwish1 as $resw1) {

                            $resultwishid2 = $database2->select('commerce_product_variation_field_data', 'pro')
                                    ->fields('pro')
                                    ->condition('product_id', $resw1->entity_id, '=')
                                    ->execute()
                                    ->fetchAll();

                            if (!empty($resultwishid2)) {
                                foreach ($resultwishid2 as $proid) {
                                    $resultwish = $database2->select('commerce_wishlist_item', 'cwi')
                                            ->fields('cwi')
                                            ->condition('purchasable_entity', $proid->variation_id)
                                            ->execute()
                                            ->fetchAll();

                                    if (!empty($resultwish)) {

                                        foreach ($resultwish as $resw2) {
                                            $resultwishid = $database2->select('commerce_wishlist', 'cww')
                                                    ->fields('cww')
                                                    ->condition('wishlist_id', $resw2->wishlist_id)
                                                    ->execute()
                                                    ->fetchAll();
                                            $obj_wishlist[] = [
                                                'customer_id' => $resultwishid[0]->uid,
                                                'product_id' => $resw1->entity_id,
                                            ];
                                        }
                                    }
                                }
                            }
                        }
                    }
                    $wishrangecheck = $database23->select('routee_range', 'rr')
                            ->fields('rr')
                            ->condition('type', '4', "=")
                            ->condition('uuid', $all->uuid, "=")
                            ->condition('store_id', $all->store_id, "=")
                            ->execute()
                            ->fetchAll();
                    if (empty(count($wishrangecheck))) {
                        $range = count($resultwish1);
                        $database = \Drupal::database();
                        $database->insert('routee_range')->fields(
                                array(
                                    'uuid' => $all->uuid,
                                    'type' => 4,
                                    'range' => $range,
                                    'store_id' => $all->store_id,
                                    'category' => 'wishlist',
                                    'username' => $all->username,
                                    'data' => count($wishtotal1),
                                )
                        )->execute();
                    }
                }
                // end wishlist data

                /*
                * Subsciber block added later to send subscriber information over routee
                * Added by Kapil Hanswal
                */
                $subscribertotal = 0;

                $subscribertotal1 = $database2->select('simplenews_subscriber', 'ss')
                        ->fields('ss')
                        ->execute()
                        ->fetchAll();
                if (!empty($subscribertotal1)) {
                    $subscribertotal = count($subscribertotal1);
                }
                $subscriberrange = $database23->select('routee_range', 'rr')
                        ->fields('rr')
                        ->condition('type', '5', "=")
                        ->condition('uuid', $all->uuid, "=")
                        ->condition('store_id', $all->store_id, "=")
                        ->execute()
                        ->fetchAll();
                if (!empty($subscriberrange)) {
                    foreach ($subscriberrange as $ressubscriber) {
                        $rng5 = $ressubscriber->range;
                        if ($ressubscriber->range != count($subscribertotal1) && $ressubscriber->range < count($subscribertotal1)) {
                            $range_update_sub = $database2->update('routee_range')
                                    ->fields([
                                        'range' => $ressubscriber->range + $limit,
                                    ])
                                    ->condition('store_id', $all->store_id, '=')
                                    ->condition('uuid', $all->uuid, '=')
                                    ->condition('type', 5, '=')
                                    ->condition('id', $ressubscriber->id, '=')
                                    ->execute();
                        } else {
                            $range_update_sub = $database2->update('routee_range')
                                    ->fields([
                                        'status' => 1,
                                    ])
                                    ->condition('store_id', $all->store_id, '=')
                                    ->condition('uuid', $all->uuid, '=')
                                    ->condition('type', 5, '=')
                                    ->condition('id', $ressubscriber->id, '=')
                                    ->execute();
                        }
                    }
                }

                $resultsub1 = $database2->select('simplenews_subscriber', 'ss')
                        ->fields('ss')
                        ->range($rng5, $limit)
                        ->execute()
                        ->fetchAll();
                if (count($subscribertotal1) <= $limit) {
                    if (!empty($subscribertotal1)) {
                        foreach ($subscribertotal1 as $ress1) {
                            $resultsubid2 = $database2->select('simplenews_subscriber__subscriptions', 'sss')
                                    ->fields('sss')
                                    ->condition('entity_id', $ress1->id)
                                    ->execute()
                                    ->fetchAll();
                             if (!empty($resultsubid2)) {
                            foreach ($resultsubid2 as $proid) {
                                $limitless_data5 = $database2->select('routee_limitless', 'rl')
                                        ->fields('rl')
                                        ->condition('type', '5', "=")
                                        ->condition('uuid', $all->uuid, "=")
                                        ->condition('store_id', $all->store_id, "=")
                                        ->execute()
                                        ->fetchAll();
                                
                                if (empty($limitless_data5)) {
                                    $obj_subscriber[] = [
                                        'customer_id' => $ress1->uid,
                                        'id_shop' => $all->store_id,
                                        'id_shop_group' => $all->store_id,
                                        'email' => $ress1->mail,
                                        'newsletter_date_add' => date("Y-m-d",$ress1->created),
                                        'ip_registration_newsletter' => 'N/A',
                                        'http_referer' => 'N/A',
                                        'active' => $proid->subscriptions_status
                                    ];
                                }
                            }
                        }
                    }
                    }
                    $back_status_subscriber = 1;
                } else if (count($subscribertotal1) > $limit) {
                    if (!empty($resultsub1)) {
                        foreach ($resultsub1 as $ress1) {

                            $resultsubid2 = $database2->select('simplenews_subscriber__subscriptions', 'sss')
                                    ->fields('sss')
                                    ->condition('entity_id', $ress1->id, '=')
                                    ->execute()
                                    ->fetchAll();

                            if (!empty($resultsubid2)) {
                                foreach ($resultsubid2 as $proid) {
                                    $obj_subscriber[] = [
                                        'customer_id' => $ress1->uid,
                                        'id_shop' => $all->store_id,
                                        'id_shop_group' => $all->store_id,
                                        'email' => $ress1->mail,
                                        'newsletter_date_add' => date("Y-m-d",$ress1->created),
                                        'ip_registration_newsletter' => 'N/A',
                                        'http_referer' => 'N/A',
                                        'active' => $proid->subscriptions_status
                                    ];                                
                                }
                            }
                        }
                    }
                    $subrangecheck = $database23->select('routee_range', 'rr')
                            ->fields('rr')
                            ->condition('type', '5', "=")
                            ->condition('uuid', $all->uuid, "=")
                            ->condition('store_id', $all->store_id, "=")
                            ->execute()
                            ->fetchAll();
                    if (empty(count($subrangecheck))) {
                        $range = count($resultsub1);
                        $database = \Drupal::database();
                        $database->insert('routee_range')->fields(
                                array(
                                    'uuid' => $all->uuid,
                                    'type' => 5,
                                    'range' => $range,
                                    'store_id' => $all->store_id,
                                    'category' => 'subscriber',
                                    'username' => $all->username,
                                    'data' => count($subscribertotal1),
                                )
                        )->execute();
                    }
                }
                // end subscriber data

                if ($back_status_order == 1) {
                    $database = \Drupal::database();
                    $limitless_dat1 = $database->select('routee_limitless', 'rl')
                            ->fields('rl')
                            ->condition('type', '1', "=")
                            ->condition('uuid', $all->uuid, "=")
                            ->condition('store_id', $all->store_id, "=")
                            ->execute()
                            ->fetchAll();
                    if (empty($limitless_dat1)) {
                        $database->insert('routee_limitless')->fields(
                                array(
                                    'uuid' => $all->uuid,
                                    'type' => 1,
                                    'store_id' => $all->store_id,
                                    'category' => 'order',
                                    'username' => $all->username,
                                    'total' => count($ordertotal),
                                )
                        )->execute();
                    }
                }
                if ($back_status_product == 1) {
                    $database = \Drupal::database();
                    $limitless_dat3 = $database->select('routee_limitless', 'rl')
                            ->fields('rl')
                            ->condition('type', '3', "=")
                            ->condition('uuid', $all->uuid, "=")
                            ->condition('store_id', $all->store_id, "=")
                            ->execute()
                            ->fetchAll();
                    if (empty($limitless_dat3)) {
                        $database->insert('routee_limitless')->fields(
                                array(
                                    'uuid' => $all->uuid,
                                    'type' => 3,
                                    'store_id' => $all->store_id,
                                    'category' => 'product',
                                    'username' => $all->username,
                                    'total' => count($producttotal),
                                )
                        )->execute();
                    }
                }
                if ($back_status_client == 1) {
                    $database = \Drupal::database();
                    $limitless_dat5 = $database->select('routee_limitless', 'rl')
                            ->fields('rl')
                            ->condition('type', '2', "=")
                            ->condition('uuid', $all->uuid, "=")
                            ->condition('store_id', $all->store_id, "=")
                            ->execute()
                            ->fetchAll();
                    if (empty($limitless_dat5)) {
                        $database->insert('routee_limitless')->fields(
                                array(
                                    'uuid' => $all->uuid,
                                    'type' => 2,
                                    'store_id' => $all->store_id,
                                    'category' => 'customer',
                                    'username' => $all->username,
                                    'total' => count($clienttotal),
                                )
                        )->execute();
                    }
                }
                if ($back_status_wishlist == 1) {
                    $database = \Drupal::database();
                    $limitless_dat4 = $database->select('routee_limitless', 'rl')
                            ->fields('rl')
                            ->condition('type', '4', "=")
                            ->condition('uuid', $all->uuid, "=")
                            ->condition('store_id', $all->store_id, "=")
                            ->execute()
                            ->fetchAll();
                    if (empty($limitless_dat4)) {
                        $database->insert('routee_limitless')->fields(
                                array(
                                    'uuid' => $all->uuid,
                                    'type' => 4,
                                    'store_id' => $all->store_id,
                                    'category' => 'wishlist',
                                    'username' => $all->username,
                                    'total' => count($wishtotal),
                                )
                        )->execute();
                    }
                }
                if ($back_status_subscriber == 1) {
                    $database = \Drupal::database();
                    $limitless_dat2 = $database->select('routee_limitless', 'rl')
                            ->fields('rl')
                            ->condition('type', '5', "=")
                            ->condition('uuid', $all->uuid, "=")
                            ->condition('store_id', $all->store_id, "=")
                            ->execute()
                            ->fetchAll();
                    if (empty($limitless_dat2)) {
                        $database->insert('routee_limitless')->fields(
                                array(
                                    'uuid' => $all->uuid,
                                    'type' => 5,
                                    'store_id' => $all->store_id,
                                    'category' => 'subscriber',
                                    'username' => $all->username,
                                    'total' => count($subscribertotal1),
                                )
                        )->execute();
                    }
                }
                $all1 = [];
                
                if (!empty($obj_cus)) {
                    $cus = ["name" => "customers",
                        "description" => "shop customers",
                        "object" => $obj_cus
                    ];
                    array_push($all1, $cus);                    
                }
                if (!empty($obj_client)) {
                    $client = ["name" => "client",
                        "description" => "shop client",
                        "object" => $obj_client
                    ];
                    array_push($all1, $client);                    
                }

                if (!empty($obj_product)) {
                    $pro = [
                        "name" => "products",
                        "description" => "shop products",
                        "object" => $obj_product
                    ];
                    array_push($all1, $pro);            
                }

                if (!empty($obj_order)) {
                    $ord = ["name" => "orders",
                        "description" => "shop orders",
                        "object" => $obj_order
                    ];
                    array_push($all1, $ord);                    
                }
                
                if (!empty($obj_wishlist)) {
                    $wis = ["name" => "wishlist",
                        "description" => "shop wishlists",
                        "object" => $obj_wishlist
                    ];
                    array_push($all1, $wis);                    
                }

                if (!empty($obj_subscriber)) {
                    $sub = ["name" => "subscriber",
                        "description" => "shop subscribers",
                        "object" => $obj_subscriber
                    ];
                    array_push($all1, $sub);                    
                }
                $data1 = array("uuid" => "$all->uuid",
                    "data" =>
                    $all1,
                );
              
                $data_string1 = json_encode($data1);

                $ch1 = curl_init('https://idata.routee.net/api/data');
                curl_setopt($ch1, CURLOPT_CUSTOMREQUEST, "POST");
                curl_setopt($ch1, CURLOPT_POSTFIELDS, $data_string1);
                curl_setopt($ch1, CURLOPT_RETURNTRANSFER, true);
                curl_setopt($ch1, CURLOPT_HTTPHEADER, array(
                    'Content-Type: application/json',
                    'Content-Length: ' . strlen($data_string1))
                );
                $resultmass = curl_exec($ch1);
                curl_close($ch1);

                $responsemass = json_decode($resultmass);
                if (!empty($responsemass->message)) {
                    drupal_set_message(t('data sent successfully'));
                }
                //end mass data code
                $rangest = $database2->select('routee_range', 'rr1')
                        ->fields('rr1')
                        ->condition('uuid', $all->uuid)
                        ->condition('store_id', $all->store_id)
                        ->execute()
                        ->fetchAll();
                $state = [];
                foreach ($rangest as $rrn) {
                    $state[] = $rrn->status;
                }
                if (!in_array(0, $state)) {
                    db_update('routee_waymore')
                            ->fields([
                                'status_back' => 1,
                            ])
                            ->condition('uuid', $all->uuid)
                            ->condition('store_id', $all->store_id)
                            ->execute();
                } else if ($back_status_product == 1 && $back_status_order == 1 && $back_status_client == 1 && $back_status_wishlist == 1 && $back_status_subscriber == 1) {
                    db_update('routee_waymore')
                            ->fields([
                                'status_back' => 1,
                            ])
                            ->condition('uuid', $all->uuid)
                            ->condition('store_id', $all->store_id)
                            ->execute();
                }

                $html = "data sent successfully of store $all->store_id";
            }
            $this->curl();
        } else {
            $html = "Authenticate Users not available";
        }
        $build[] = array('#markup' => 'Data sent Successfully');
        return $build;
    }

    public function curl() {
        $this->content();
        $build[] = array('#markup' => 'Data sent Successfully');
        return $build;
    }

    public function curl_store() {
        $text = [];
        $uuid = [];
        $database3 = \Drupal::database();
        $result2 = $database3->select('routee_waymore', 'rw1')
                ->fields('rw1')
                ->execute()
                ->fetchAll();
        if (!empty($result2)) {
            foreach ($result2 as $res) {
                if ($res->status_back == 0) {
                    $text[] = '0';
                    $uuid[] = $res->uuid;
                }if ($res->status_back == 1) {
                    $text[] = '1';
                    $uuid[] = $res->uuid;
                }
            }
        }
        $r['html'] = $text;
        $r['uuid'] = $uuid;
        return new JsonResponse($r);
    }

    public function stores() {
        global $base_url;
        $userCurrent = \Drupal::currentUser();
        $user = \Drupal\user\Entity\User::load($userCurrent->id());
        $uid = $user->get('uid')->value;
        $html = '';
        $disable = '';
        $id = [];
        $id33 = [];

        $database = \Drupal::database();
        $result = $database->select('commerce_store_field_data', 'cs')
                ->fields('cs')
                ->execute()
                ->fetchAll();
        $database3 = \Drupal::database();
        $result3 = $database3->select('routee_waymore', 'rw')
                ->fields('rw')
                ->condition('status', 1, "=")
                ->condition('status_back', 1, "=")
                ->execute()
                ->fetchAll();
        $result34 = $database3->select('routee_waymore', 'rw')
                ->fields('rw')
                ->condition('status', 1, "=")
                ->condition('status_back', 0, "=")
                ->execute()
                ->fetchAll();
        if (!empty($result3)) {
            foreach ($result3 as $auth) {
                $id[] = $auth->store_id;
            }
        }
        if (!empty($result34)) {
            foreach ($result34 as $auth33) {
                $id33[] = $auth33->store_id;
            }
        }
        if (count($result) == 0) {
            $html.='<div style="text-align:center;font-size:15px;">You have not created any store yet please create store <a href="' . $base_url . '/store/add/online" style="text-decoration:underline;" target="_blank">Create Store</a>';
        } elseif (count($result) != 0) {
            $html.="<table  class='storetable' style='width:100%;'><caption style='font-size: 15px;margin-top: 12px;margin-bottom: 12px;font-weight: bold;'>Store Listing</caption><tr style='border: none;'><th style='width:25%;'>S.no</th>
                               <th  style='width:25%;'>Store Name</th>
                               <th style='width:25%;'>Uuid</th>
                               <th style='width:25%;'></th>
                               <th></th>
                               <th></th>
                               </tr>";
            $i = 1;
            foreach ($result as $value) {
                $result2 = $database->select('routee_waymore', 'rw1')
                        ->fields('rw1')
                        ->condition('store_id', $value->store_id, "=")
                        ->execute()
                        ->fetchAll();
                if (in_array($value->store_id, $id)) {
                    $disable = 'disabled';
                    $button_name = 'Authenticated';
                } else if (in_array($value->store_id, $id33)) {
                    $disable = 'disabled';
                    $button_name = 'Integrating...';
                } else if (!in_array($value->store_id, $id33) && !in_array($value->store_id, $id)) {
                    $disable = '';
                    $button_name = 'Authenticate';
                }
                $html.='<tr style="border: none;"><td style="width:25%;">' . $i . '</td>
                        <td style="width:25%;" > ' . $value->name . '</td>';
                if (!empty($result2[0]->uuid)) {
                    $html.='     <td style="width:25%;" class="uuid" id=' . $result2[0]->uuid . '>' . $result2[0]->uuid . '</td>';
                } else {
                    $html.='     <td style="width:25%;">Null</td>';
                }
                $html.='    <td  style="width:25%;">
                            <a href="' . $base_url . '/admin/config/routee_waymore/configuration?storeid=' . $value->store_id . '&uid=' . $uid . '" target="_blank">
                            <button class="button changebtn"  ' . $disable . '>' . $button_name . '</button></a></td>   
                        </td></tr>';
                $i++;
            }
            $html.="</table>";
        }
        $build[] = array('#markup' => t($html));
        return $build;
    }

}